<?php
/**
 * @package	HikaShop for Joomla!
 * @version	4.7.0
 * @author	hikashop.com
 * @copyright	(C) 2010-2023 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Form\Form;
use Baikalsr\Api\Tools;

$path = realpath(__DIR__).DS.$this->element->shipping_type.'.xml';
$data = file_get_contents($path);
$form_def = '<?xml version="1.0" encoding="utf-8"?>'.preg_replace('#</config>.*#is','</form>',preg_replace('#(<\?xml version="1\.(1|0)" encoding="utf-8"\?>).*<config#is','<form',$data));
$form = JForm::getInstance('myform', $form_def);
$form->bind(array("params"=>$this->element->shipping_params));

foreach ($form->getFieldsets('params') as $fieldsets => $fieldSet){
	$label = !empty($fieldSet->label) ? JText::_($fieldSet->label) : '';
	$class = isset($fieldSet->class) && !empty($fieldSet->class) ? $fieldSet->class : '';
	//fix for fieldsets showon
	$showOn = '';
	if($fieldSet->name == "departure_prr_group")
		$showOn = "data-showon='[{\"field\":\"data[shipping][shipping_params][departure_from_address]\",\"values\":[\"1\"],\"sign\":\"=\",\"op\":\"\"}]'"; 
	?>
	<tr <?=$showOn;?>>
		<td class="key" >
			<div>
				<label><?php echo $label; ?></label>
			</div>
		</td>
				
		<td class="fieldset-render">
		<?php foreach($form->getFieldset($fieldSet->name) as $field){
			$field_extension = $field->getAttribute("extension") ? $field->getAttribute("extension") : '';
			if ($field->hidden){
				if ($field_extension != "plg_baikalsr")
					echo $field->input;
			} else { ?>
				<div class="row-fluid">
					<?php 
					$html = $field->renderField();
					//fix for saving
					$html = str_replace('"field":"params[', '"field":"data[shipping][shipping_params][', $html);
					//fix for showon attribute
					$html = str_replace('name="params[', 'name="data[shipping][shipping_params][', $html);				
					echo $html;?>
				</div>
			<?php 
			}
		}?>
		</td>
	</tr>
	<?php
}
?>
