<?php
defined('_JEXEC') or die();

JLoader::register('Baikalsr\Lib\Tools', dirname(__FILE__) . '/../lib/tools.php');

class JFormFieldBslist extends JFormField
{

    var $type = 'Bslist';
	
	protected function _getLegalForm()
    {
		return 1;
	}
	
    protected function getInput()
    {
        $options = [];

		$attr = '';

		// Initialize some field attributes.
		$attr .= !empty($this->class) ? ' class="' . $this->class . '"' : '';
		$attr .= $this->disabled ? ' disabled' : '';
		$attr .= $this->multiple ? ' multiple' : '';
		$attr .= $this->required ? ' required aria-required="true"' : '';
		$attr .= $this->autofocus ? ' autofocus' : '';
		$attr .= $this->getAttribute("target") ? ' data-url="' . $this->getAttribute("target") . '"' : '';
		
		// Initialize JavaScript field attributes.
		$attr .= !empty($this->onchange) ? ' onchange="' . $this->onchange . '"' : '';
		$attr .= !empty($this->onclick) ? ' onclick="' . $this->onclick . '"' : '';
		
		$shipping_id = 0;
		
		$baikalsrTools = new Baikalsr\Lib\Tools();

		$action = hikaInput::get()->getCmd('subtask', '');

		if( $action == "shipping_edit" ){				
			$shipping_id = hikaInput::get()->getInteger('shipping_id', 0);
		}elseif( $action == "popupShow"){
			$order_id = hikashop_getCID('order_id');
			$orderClass = hikashop_get('class.order');
			$order = $orderClass->loadFullOrder($order_id);
			$shipping_id = $order->order_shipping_id;
		}

		if(!empty($shipping_id)){
			//get shipment config
			$shippingClass = hikashop_get('class.shipping');
			$config = $shippingClass->get($shipping_id);
			if (isset($config->shipping_params->test) && isset($config->shipping_params->authKeyTest) && isset($config->shipping_params->authKey)){
				if($config->shipping_params->test){
					$baikalsrTools::defineAuthParams( $config->shipping_params->authKeyTest, true );
				}else{
					$baikalsrTools::defineAuthParams( $config->shipping_params->authKey, false );
				}
			}
		}
		
		$action = $this->getAttribute("target");
		switch ($action) {
			case 'getContragents':
				$response = $baikalsrTools::getContragents();
				if(isset($response) && !empty($response)){
					foreach ($response as $data){
						if(isset($data["name"]) && !empty($data["name"])
							&&	isset($data["guid"]) && !empty($data["guid"]))
							$options[] = JHTML::_('select.option', $data['guid'] , $data['name']);
					}
				}	
				break;
			case 'getOpf':
				$response = $baikalsrTools::_getPartnerTypes();	
				if(!empty($response)){
					foreach ($response as $data){
						if(isset($data["legalForm"]) && $data["legalForm"] == 1)
							if(isset($data["name"]) && !empty($data["name"])
								&&	isset($data["id"]) && !empty($data["id"]))
							$options[$data['id']] = JHTML::_('select.option', $data['id'] , $data['name']);
					}
				}
				break;
			case 'getDocuments':
				$response = $baikalsrTools::_getPartnerTypes();	
				if(!empty($response)){
					foreach ($response as $data){
						if(isset($data["legalForm"]) && $data["legalForm"] == 2)
							if(isset($data["name"]) && !empty($data["name"])
								&&	isset($data["id"]) && !empty($data["id"]))
								$options[$data['id']] = JHTML::_('select.option', $data['id'] , $data['name']);
					}
				}
				break;
			case 'getTerminals':
				$guid = $this->form->getValue("departure_guid", "params");
				$terminal_type = "start";
				if($this->fieldname == "destination_terminal_id"){					
					$guid = $this->form->getValue("destination_guid", "params");
					$terminal_type = "finish";
				}
				$response = $baikalsrTools::_getAffiliateData($guid);
				if (isset($response["terminals"]) && !empty($response["terminals"])) {
					foreach($response["terminals"] as $data) {
						if (isset($data[$terminal_type]) && $data[$terminal_type]){ 
							if(!isset($data['id']) || empty($data['id']))
								$data['id'] = 0;
							if(isset($data['name']) && !empty($data['name']))
								$options[] = JHTML::_('select.option', $data['id'] , $data['name']." (".$baikalsrTools::htmlspecialcharsBack($data["address"]).")");
						}
					}
				}
				break;
			case 'getPacking':
				$options[] = JHTML::_('select.option', 0 , JText::_('PLG_HIKASHOPSHIPPING_NO_PACKING'));				
				$options[] = JHTML::_('select.option', 19 , JText::_('PLG_HIKASHOPSHIPPING_PACKING_1'));
				$options[] = JHTML::_('select.option', 21 , JText::_('PLG_HIKASHOPSHIPPING_PACKING_2'));
				$options[] = JHTML::_('select.option', 22 , JText::_('PLG_HIKASHOPSHIPPING_PACKING_3'));
				$options[] = JHTML::_('select.option', 23 , JText::_('PLG_HIKASHOPSHIPPING_PACKING_4'));
				$options[] = JHTML::_('select.option', 24 , JText::_('PLG_HIKASHOPSHIPPING_PACKING_5'));
				$options[] = JHTML::_('select.option', 2770 , JText::_('PLG_HIKASHOPSHIPPING_PACKING_6'));
				$options[] = JHTML::_('select.option', 2797 , JText::_('PLG_HIKASHOPSHIPPING_PACKING_7'));
				$options[] = JHTML::_('select.option', 2820 , JText::_('PLG_HIKASHOPSHIPPING_PACKING_8'));
				$options[] = JHTML::_('select.option', 3228 , JText::_('PLG_HIKASHOPSHIPPING_PACKING_9'));
				break;
			case 'getCargoTypes':
				$response = $baikalsrTools::_getCargoTypes();
				if(isset($response) && !empty($response)){
					foreach ($response as $data){
						$options[] = JHTML::_('select.option', $data['id'] , $data['name']);
					}
				}
				break;
		}
		
		if(empty($options)){
			$options[] = JHTML::_('select.option', '', JText::_('PLG_HIKASHOPSHIPPING_NO_DATA'));
		}

		$html = '<select id="' . $this->id . '" name="' . $this->name . '" '. $attr .'>';
        $html .= JHTMLSelect::Options( $options, 'value', 'text', $this->value, false );
        $html .= '</select>';
        return $html;
    }
}
