<?php

defined('_JEXEC') or die;

//define('DS', DIRECTORY_SEPARATOR);

jimport ('joomla.filesystem.folder');

class plgHikashopshippingBaikalsrInstallerScript
{

    private $minimum_php_release = '7.1.0';


    function preflight($type, $parent)
    {
        $error = 0;
        $app = JFactory::getApplication();
        if (version_compare(phpversion(), $this->minimum_php_release, '<')) {
            $app->enqueueMessage('Plugin requires PHP ' . $this->minimum_php_release . ' or later version!', 'error');
            $error = 1;
        }
        if (!file_exists(JPATH_SITE . '/components/com_hikashop/hikashop.php')) {
            $app->enqueueMessage('Please install component \"hikashop\"', 'error');
            $error = 1;
        }
        if ($error) {
            $app->enqueueMessage('The installation was canceled', 'error');
            return false;
        }
		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')){
			echo 'This module can not work without the Hikashop Component';
			return;
		}
    }

	/**
     * Called after any type of action
     *
     * @param   string  $route  Which action is happening (install|uninstall|discover_install)
     * @param   JAdapterInstance  $adapter  The object responsible for running this script
     *
     * @return  boolean  True on success
     */
    public function postflight($route, JAdapterInstance $adapter){

		$dst = JPATH_ROOT .'/media/com_hikashop/images/shipping';
		if(!JFolder::exists($dst)){
			JFolder::create ($dst);
		}
		
		$src = dirname(__FILE__) .'/assets/images';
		$this->_recurse_copy($src,$dst);
		
		// adding custom field in address	
		$field = [];	
		$field['field_table'] = 'address';
		$field['field_realname'] = 'GUID';
		$field['field_namekey'] = 'baikalsr_city';
		$field['field_type'] = 'hidden';
		$field['field_value'] = '';
		$field['field_published'] = 1;
		$field['field_ordering'] = 16;
		$field['field_options'] = 'a:5:{s:12:"errormessage";s:0:"";s:4:"cols";s:0:"";s:4:"rows";s:0:"";s:4:"size";s:0:"";s:6:"format";s:0:"";}';
		$field['field_core'] = 0;
		$field['field_required'] = 0;
		$field['field_default'] = '';
		$field['field_access'] = 'all';
		$field['field_categories'] = 'all';
		$field['field_with_sub_categories'] = 0;
		$field['field_frontcomp'] = 1;
		$field['field_backend'] = 1;
		$field['field_backend_listing'] = 0;
		$field['field_display'] = '';
		
		$db = JFactory::getDBO();
		$data = array(
			'field_table' => $db->quote($field['field_table']),
			'field_realname' => $db->quote($field['field_realname']),
			'field_namekey' => $db->quote($field['field_namekey']),
			'field_type' => $db->quote($field['field_type']),
			'field_value' => $db->quote($field['field_value']),
			'field_options' => $db->quote($field['field_options']),
			'field_default' => $db->quote($field['field_default']),
			'field_access' => $db->quote($field['field_access']),
			'field_categories' => $db->quote($field['field_categories']),
			'field_display' => $db->quote($field['field_display']),
		);
		$data = array_merge($field, $data);	
		//$field->field_payment_id = '';
		//$field->field_shipping_id = '';
		try
		{
			$query = $db->getQuery(true);
			$query = 'INSERT IGNORE INTO '.hikashop_table('field').' ('.implode(',', array_keys($data)).') VALUES ('.implode(',', array_values($data)).')';
			$db->setQuery($query)->execute();
		}
		catch (Exception $e)
		{
			// If that fails it's not the end of the world. The component is still usable, so just swallow any
			// exception.
		}
		
		try {
			$query = $db->getQuery(true);
			$query = 'ALTER TABLE '.hikashop_table($field['field_table']).' ADD `'.$field['field_namekey'].'` LONGTEXT NULL';
			$db->setQuery($query)->execute();
		}catch(Exception $e) {
			// If that fails it's not the end of the world. The component is still usable, so just swallow any
			// exception.
		}
		
        return True;
	}
	
    function install(&$plg)
    {
        return true;
    }


    function uninstall(&$plg)
    {
        return true;
    }
	
	/**
	 * copy all $src to $dst folder and remove it
	 *
	 * @param String $src path
	 * @param String $dst path
	 * @param String $type modulesBE, modules, plugins, languageBE, languageFE
	 */
	private function _recurse_copy ($src, $dst) {

		static $failed = false;
		$dir = opendir ($src);

		if (is_resource ($dir)) {
			while (FALSE !== ($file = readdir ($dir))) {
				if (($file != '.') && ($file != '..')) {
					if (is_dir ($src . DS . $file)) {
						if(!JFolder::create($dst . DS . $file)){
							$app = JFactory::getApplication ();
							$app->enqueueMessage ('Couldnt create folder ' . $dst . DS . $file);
						}
						$this->recurse_copy ($src . DS . $file, $dst . DS . $file);
					} else {
						if (JFile::exists ($dst . DS . $file)) {
							if (!JFile::delete ($dst . DS . $file)) {
								$app = JFactory::getApplication ();
								$app->enqueueMessage ('Couldnt delete ' . $dst . DS . $file);
								//return false;
							}
						}
						if (!JFile::move ($src . DS . $file, $dst . DS . $file)) {
							$app = JFactory::getApplication ();
							$app->enqueueMessage ('Couldnt move ' . $src . DS . $file . ' to ' . $dst . DS . $file);
							$failed = true;
							//return false;
						}
					}
				}
			}
			closedir ($dir);
			if (is_dir ($src) and !$failed) {
				JFolder::delete ($src);
			}
		} else {
			$app = JFactory::getApplication ();
			$app->enqueueMessage ('Baikalsr Installer recurse_copy; Couldnt read source directory '.$dir);
			return false;
		}
		return true;
	}
}


