<?php
namespace Baikalsr\Lib;
require_once( dirname(__FILE__) . DS . 'api.php' );

class Tools extends Api
{	
		
	public function __construct()
	{
		parent::__construct ();
	}
	
	public static function _getCityByName($city_name)
	{
		if(empty($city_name))
			return [];
		jimport('joomla.cache.cache');
		$cache_id = preg_replace('/\s|\&|\.|\,|\-|\+/', '', 'baikalsr_city-' . self::translit($city_name) );
		$conf = \JFactory::getConfig();
		$options = array(
			'defaultgroup' 	=> 'plg_baikalsr_shipping',
			'cachebase' 	=> $conf->get('cache_path', JPATH_CACHE),
			'lifetime' 		=> 10*60,
			'language' 		=> $conf->get('language', 'en-GB'),
			'storage' 		=> $conf->get('cache_handler', ''),
			'caching' 		=> true,
		);
		$cache = new \JCache($options);
		// Проверим есть ли кешированное значение
		if ($cache->contains($cache_id)){
			$result = unserialize($cache->get($cache_id));
		}else{
			$result = parent::getCityByName($city_name);
			if(!empty($result))
				$cache->store(serialize($result), $cache_id, 'plg_baikalsr_shipping');
		}
		return $result;
	}
	
    public static function _getCityByGuid($city_guid)
	{
		if(empty($city_guid))
			return [];
		jimport('joomla.cache.cache');
		$cache_id = preg_replace('/\s|\&|\.|\,|\-|\+/', '', 'baikalsr_city_guid-' . $city_guid );
		$conf = \JFactory::getConfig();
		$options = array(
			'defaultgroup' 	=> 'plg_baikalsr_shipping',
			'cachebase' 	=> $conf->get('cache_path', JPATH_CACHE),
			'lifetime' 		=> 10*60,
			'language' 		=> $conf->get('language', 'en-GB'),
			'storage' 		=> $conf->get('cache_handler', ''),
			'caching' 		=> true,
		);
		$cache = new \JCache($options);
		// Проверим есть ли кешированное значение
		if ($cache->contains($cache_id)){
			$result = unserialize($cache->get($cache_id));
		}else{
			$result = parent::getCityByGuid($city_guid);
			if(!empty($result))
				$cache->store(serialize($result), $cache_id, 'plg_baikalsr_shipping');
		}
		return $result;
	}
	
    public static function _getStreetByGuid($street_guid)
	{
		if(empty($street_guid))
			return [];
		jimport('joomla.cache.cache');
		$cache_id = preg_replace('/\s|\&|\.|\,|\-|\+/', '', 'baikalsr_street_guid-' . $street_guid );
		$conf = \JFactory::getConfig();
		$options = array(
			'defaultgroup' 	=> 'plg_baikalsr_shipping',
			'cachebase' 	=> $conf->get('cache_path', JPATH_CACHE),
			'lifetime' 		=> 10*60,
			'language' 		=> $conf->get('language', 'en-GB'),
			'storage' 		=> $conf->get('cache_handler', ''),
			'caching' 		=> true,
		);
		$cache = new \JCache($options);
		// Проверим есть ли кешированное значение
		if ($cache->contains($cache_id)){
			$result = unserialize($cache->get($cache_id));
		}else{
			$result = parent::getStreetByGuid($street_guid);
			if(!empty($result))
				$cache->store(serialize($result), $cache_id, 'plg_baikalsr_shipping');
		}
		return $result;
	}
	
	public static function _getAffiliateData($city_guid)
	{
		if(empty($city_guid))
			return [];
		jimport('joomla.cache.cache');
		$cache_id = preg_replace('/\s|\&|\.|\,|\-|\+/', '', 'baikalsr_terminals-' . $city_guid );
		$conf = \JFactory::getConfig();
		$options = array(
			'defaultgroup' 	=> 'plg_baikalsr_shipping',
			'cachebase' 	=> $conf->get('cache_path', JPATH_CACHE),
			'lifetime' 		=> 10*60,
			'language' 		=> $conf->get('language', 'en-GB'),
			'storage' 		=> $conf->get('cache_handler', ''),
			'caching' 		=> true,
		);
		$cache = new \JCache($options);
		// Проверим есть ли кешированное значение
		if ($cache->contains($cache_id)){
			$result = unserialize($cache->get($cache_id));
		}else{
			$result = parent::getAffiliateData($city_guid);
			if(!empty($result))
				$cache->store(serialize($result), $cache_id, 'plg_baikalsr_shipping');
		}
		return $result;
	}
	
	public static function _getCargoTypes()
	{
		//return [];
		jimport('joomla.cache.cache');
		$cache_id = preg_replace('/\s|\&|\.|\,|\-|\+/', '', 'baikalsr_cargotypes' );
		$conf = \JFactory::getConfig();
		$options = array(
			'defaultgroup' 	=> 'plg_baikalsr_shipping',
			'cachebase' 	=> $conf->get('cache_path', JPATH_CACHE),
			'lifetime' 		=> 10*600,
			'language' 		=> $conf->get('language', 'en-GB'),
			'storage' 		=> $conf->get('cache_handler', ''),
			'caching' 		=> true,
		);
		$cache = new \JCache($options);
		// Проверим есть ли кешированное значение
		if ($cache->contains($cache_id)){
			$result = unserialize($cache->get($cache_id));
		}else{
			$result = parent::getCargoTypes();
			if(!empty($result))
				$cache->store(serialize($result), $cache_id, 'plg_baikalsr_shipping');
		}
		return $result;
	}
	
	public static function _getPartnerTypes()
	{
		//return [];
		jimport('joomla.cache.cache');
		$cache_id = preg_replace('/\s|\&|\.|\,|\-|\+/', '', 'baikalsr_partnertypes' );
		$conf = \JFactory::getConfig();
		$options = array(
			'defaultgroup' 	=> 'plg_baikalsr_shipping',
			'cachebase' 	=> $conf->get('cache_path', JPATH_CACHE),
			'lifetime' 		=> 10*600,
			'language' 		=> $conf->get('language', 'en-GB'),
			'storage' 		=> $conf->get('cache_handler', ''),
			'caching' 		=> true,
		);
		$cache = new \JCache($options);
		// Проверим есть ли кешированное значение
		if ($cache->contains($cache_id)){
			$result = unserialize($cache->get($cache_id));
		}else{
			$result = parent::getPartnerTypes();
			if(!empty($result))
				$cache->store(serialize($result), $cache_id, 'plg_baikalsr_shipping');
		}
		return $result;
	}
	
	public static function _calculate($preorderData)
	{	
		jimport('joomla.cache.cache');			
		$cache_id = preg_replace('/\s|\&|\.|\,|\-|\+/', '', 'baikalsr_calc-' . $preorderData['departure_guid'] . $preorderData['departure_from_address'] . $preorderData['destination_guid'] . $preorderData['weight'] . $preorderData['volume'] . $preorderData['estimated_cost'] . $preorderData['packing_id']);
		$conf = \JFactory::getConfig();
		$options = array(
			'defaultgroup' 	=> 'plg_baikalsr_shipping',
			'cachebase' 	=> $conf->get('cache_path', JPATH_CACHE),
			'lifetime' 		=> 10*60,
			'language' 		=> $conf->get('language', 'en-GB'),
			'storage' 		=> $conf->get('cache_handler', ''),
			'caching' 		=> true,
		);
		$cache = new \JCache($options);

		// Проверим есть ли кешированное значение
		if ($cache->contains($cache_id)){
			$result = unserialize($cache->get($cache_id));
		}else{
			//Всегда считаем доставку по адресу
			$preorderData['destination_to_address'] = true;
			$result = parent::calculate($preorderData);
			if(!empty($result))
				$cache->store(serialize($result), $cache_id, 'plg_baikalsr_shipping');
		}

		return $result;
	}
	
	public static function _getLocationWithGUIDFromAddress($address)
	{	
		$arCity = [];
		if(isset($address->baikalsr_city) && !empty($address->baikalsr_city)){
			$arCity = self::_getCityByGuid($address->baikalsr_city);
		}else if(isset($address->address_city) && !empty($address->address_city)){
			$city = preg_replace('/\s+/', '+', trim($address->address_city));
			$arCity = self::_getCityByName($city);		
		}else if(isset($address->address_state) && !empty($address->address_state)){
			if(is_array($address->address_state))
				$address->address_state = $address->address_state[0];
			$state = self::_getStateOrCountry($address->address_state);
			$state = preg_replace('/\s+/', '+', trim($state));
			$arCity = self::_getCityByName($state);	
		}
	
		return $arCity;
	}
	
	public static function _getStateOrCountry($zone_namekey){

        $db = \JFactory::getDbo();
        $q = 'SELECT `zone_name` FROM `#__hikashop_zone` WHERE `zone_namekey` = "'.$zone_namekey.'"';
        $db->setQuery ($q);

        if (!($zoneInfo = $db->loadObject())) {
            return $db->getErrorMsg();
        }

        return $zoneInfo->zone_name;

    }
	
	public static function _getPreferredTerminal($address_id)
    {
		$db = \JFactory::getDBO();
		$query = 'SELECT * FROM ' . hikashop_table('plg_baikalsr_address') . ' WHERE address_id = ' . $address_id . ' LIMIT 1';
		$db -> setQuery($query);
		return $db->loadObject();
	} 	
	
	public static function htmlspecialcharsBack($html_text)
	{
		return html_entity_decode($html_text);
	}
	
	private static function _unserialize($data) {
		if(!is_string($data))
			return false;
		if(!preg_match_all('#[OC]:[0-9]+:"([-_a-zA-Z0-9]+)":[0-9]+:\{#iU', $data, $matches))
			return unserialize($data);
		if(!empty($matches[1])) {
			foreach($matches[1] as $m) {
				if($m != 'stdClass')
					return false;
			}
		}
		return unserialize($data);
	}
	
	public static function translit($value)
	{
		$converter = array(
			'а' => 'a',    'б' => 'b',    'в' => 'v',    'г' => 'g',    'д' => 'd',
			'е' => 'e',    'ё' => 'e',    'ж' => 'zh',   'з' => 'z',    'и' => 'i',
			'й' => 'y',    'к' => 'k',    'л' => 'l',    'м' => 'm',    'н' => 'n',
			'о' => 'o',    'п' => 'p',    'р' => 'r',    'с' => 's',    'т' => 't',
			'у' => 'u',    'ф' => 'f',    'х' => 'h',    'ц' => 'c',    'ч' => 'ch',
			'ш' => 'sh',   'щ' => 'sch',  'ь' => '',     'ы' => 'y',    'ъ' => '',
			'э' => 'e',    'ю' => 'yu',   'я' => 'ya',
	 
			'А' => 'A',    'Б' => 'B',    'В' => 'V',    'Г' => 'G',    'Д' => 'D',
			'Е' => 'E',    'Ё' => 'E',    'Ж' => 'Zh',   'З' => 'Z',    'И' => 'I',
			'Й' => 'Y',    'К' => 'K',    'Л' => 'L',    'М' => 'M',    'Н' => 'N',
			'О' => 'O',    'П' => 'P',    'Р' => 'R',    'С' => 'S',    'Т' => 'T',
			'У' => 'U',    'Ф' => 'F',    'Х' => 'H',    'Ц' => 'C',    'Ч' => 'Ch',
			'Ш' => 'Sh',   'Щ' => 'Sch',  'Ь' => '',     'Ы' => 'Y',    'Ъ' => '',
			'Э' => 'E',    'Ю' => 'Yu',   'Я' => 'Ya',
		);
	 
		$value = strtr($value, $converter);
		return $value;
	}
	
    public static function untranslit($textlat = null) {
		$cyr = array(
		'Абакан', 'Агинское', 'Анадырь', 'Архангельск', 'Астрахань', 'Барнаул', 'Белгород', 'Биробиджан', 'blagoveshchensk', 'Брянск', 'Чебоксары', 'Челябинск', 'Черкесск', 
		'Чита', 'Дудинка', 'Элиста', 'Горно-Алтайск', 'Грозный', 'Иркутск', 'Иваново', 'Ижевск', 'Калининград', 'Калуна', 'Краснодар', 'Казань', 'Кемерово', 'Хабаровск', 'Ханты-Мансийск',
		'Кострома', 'Краснодар', 'Красноярск', 'Кудымкар', 'Курган', 'Курск', 'Кызыл', 'Липетск', 'Магадан', 'Махачкала', 'Майкоп', 'Москва', 'Мурманск', 'Нальчик', 'Нарьян-Мар', 
		'Назрань', 'Нижний Новгород', 'Великий Новгород', 'Новосибирск', 'Омск', 'Орёл', 'Оренбург', 'Палана', 'Пенза', 'Пермь', 'Петропавловск-Камчатский', 'Петрозаводск', 'Псков', 
		'Ростов-на-Дону', 'Рязань', 'Салехард', 'Самара', 'Саранск', 'Саратов', 'Смоленск', 'Санкт-Петербург', 'Ставрополь', 'Сыктывкар', 'Тамбов', 'Томск', 'Тула', 'Тура', 'Тверь', 'Тюмень', 
		'Уфа', 'Ульяновск', 'Улан-Удэ', 'Усть-Ордынский', 'Владикавказ', 'Владимир', 'Владивосток', 'Волгоград', 'Вологда', 'Воронеж', 'Киров', 'Якутск', 'Ярославль', 'Екатеринбург', 
		'Йошкар-Ола');
		$lat = array(
		'abakan', 'aginskoye', 'anadyr', 'arkahangelsk', 'astrakhan', 'barnaul', 'belgorod', 'birobidzhan', 'blagoveshchensk', 'bryansk', 'cheboksary', 'chelyabinsk', 'cherkessk', 
		'chita', 'dudinka', 'elista', 'gorno-altaysk', 'groznyy', 'irkutsk', 'ivanovo', 'izhevsk', 'kalinigrad', 'kaluga', 'kasnodar', 'kazan', 'kemerovo', 'khabarovsk', 'khanty-mansiysk',
		'kostroma', 'krasnodar', 'krasnoyarsk', 'kudymkar', 'kurgan', 'kursk', 'kyzyl', 'lipetsk', 'magadan', 'makhachkala', 'maykop', 'moscow', 'murmansk', 'nalchik', 'naryan mar', 
		'nazran', 'nizhniy novgorod', 'novgorod', 'novosibirsk', 'omsk', 'orel', 'orenburg', 'palana', 'penza', 'perm', 'petropavlovsk-kamchatskiy', 'petrozavodsk', 'pskov', 
		'rostov-na-donu', 'ryazan', 'salekhard', 'samara', 'saransk', 'saratov', 'smolensk', 'st. petersburg', 'stavropol', 'syktyvkar', 'tambov', 'tomsk', 'tula', 'tura', 'tver', 'tyumen', 
		'ufa', 'ul\'yanovsk', 'ulan-ude', 'ust\'-ordynskiy', 'vladikavkaz', 'vladimir', 'vladivostok', 'volgograd', 'vologda', 'voronezh', 'vyatka', 'yakutsk', 'yaroslavl', 'yekaterinburg', 
		'yoshkar-ola');
		return str_replace($lat, $cyr, strtolower($textlat));
	}

}