<?php
defined('_JEXEC') or die();
use Joomla\CMS\Form\Form;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
	
// Access check.
if (!JFactory::getUser()->authorise('core.admin'))
{
	throw new JAccessExceptionNotallowed(JText::_('JERROR_ALERTNOAUTHOR'), 403);
}

JHtml::_('formbehavior.chosen', 'select');

// base form definition
$form = Form::getInstance("popup_shipping", realpath(__DIR__ . '/..') . '/popup_shipping.xml');
$form->bind(array("params"=>$this->form_data));
//Установим запрет на редактирование если данные отправлены по api
if(isset($this->disabled)){
	foreach ($form->getFieldset() as $field) {
		$form->setFieldAttribute($field->fieldname, "disabled", true, "params");
	}
}elseif(isset($this->warning) && count((array)$this->warning) > 0){
	foreach($this->warning as $key=>$warning){
		$attrClass = $form->getFieldAttribute($key, "class", null, "params");
		$form->setFieldAttribute($key, "class", trim($attrClass . " invalid"), "params");
	}
}
?>

<div id="popup-shipping-container" class="container-fluid">
	<input type="hidden" id="params_authKey" value="<?=$this->form_data->authKey?>"/>
	<input type="hidden" id="params_authKeyTest" value="<?=$this->form_data->authKeyTest?>"/>	
	<input type="hidden" id="params_test" value="<?=$this->form_data->test_mode?>"/>	
	<form action="<?= JRoute::_('index.php'); ?>" method="post" name="formPopupShipping" id="formPopupShipping" class="form-vertical form-popup-shipping">
		<?php if(!isset($this->disabled)):?>
			<h2><?php echo JText::_('PLG_HIKASHOPSHIPPING_POPUP_TITLE'). ' ' . $this->form_data->order_id; ?></h2>
			<div class="alert alert-info">
				<?=JText::_( 'PLG_HIKASHOPSHIPPING_INFO_POPUP_SHIPPING' ); ?>
			</div>
		<?php else:?>
			<h2><?php echo JText::_('PLG_HIKASHOPSHIPPING_POPUP_TITLE2'). ' ' . $this->form_data->request_id; ?></h2>
			<div class="alert alert-info">
				<?=JText::_( 'PLG_HIKASHOPSHIPPING_POPUP_SUCCESS_BODY'). ' '. JText::_( 'PLG_HIKASHOPSHIPPING_TRACKING_NUMBER') . ': ' . $this->form_data->tracking_number; ?> 
			</div>		
		<?php endif;?>
		<div id="popup-message-container">
			<?php if (isset($this->warning) && count((array)$this->warning) > 0):?>
			<div class="alert alert-danger alert-dismissible" role="alert">
				<button type="button" class="close" data-dismiss="alert">&times;</button>
				<h4 class="alert-heading"><i class="fa fa-exclamation-triangle" aria-hidden="true"></i>&nbsp;<?= JText::_('WARNING'); ?></h4>
				<div class="alert-message">
					<?=JText::_('PLG_HIKASHOPSHIPPING_ERROR_WARNING');?>:
					<ul>
					<?php foreach($this->warning as $warning){
						echo '<li>'.$warning.'</li>';
					}?>
					</ul>
				</div>
			</div>
			<?php endif; ?>
			<?php 
			if (isset($this->errors) && count((array)$this->errors) != 0): ?>
			<div class="alert alert-danger alert-dismissible" role="alert">
				<button type="button" class="close" data-dismiss="alert">&times;</button>
				<h4 class="alert-heading"><i class="fa fa-exclamation-triangle" aria-hidden="true"></i>&nbsp;<?= JText::_('ERROR'); ?></h4>
				<div class="alert-message">
					<?=JText::_('PLG_HIKASHOPSHIPPING_ERROR_API');?>:
					<ul>
					<?php foreach($this->errors as $error){
						echo '<li>'.$error.'</li>';
					}?>
					</ul>
				</div>
			</div>
			<?php endif; ?>
		</div>
		<fieldset class="adminform control-field">
			<legend><?php echo JText::_ ('PLG_HIKASHOPSHIPPING_CONSIGNOR_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span12"><?php //echo $form->renderFieldset('consignor_group');  ?>					
					<?php echo $form->renderField('consignor_contragent_id', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span4">
					<?php echo $form->renderField('author_lastname', 'params');?>
					<?php echo $form->renderField('author_firstname', 'params');?>
					<?php echo $form->renderField('author_middlename', 'params');?>
					<?php echo $form->renderField('consignor_fio', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('consignor_phone', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('consignor_email', 'params');?>
				</div>
			</div>
		</fieldset>
		<fieldset class="adminform control-field">
			<legend><?php echo JText::_ ('PLG_HIKASHOPSHIPPING_CONSIGNEE_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span12">
					<?= $form->renderField('consignee_physical_person', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span4">
					<?= $form->renderField('consignee_fio', 'params');?>
				</div>
				<div class="span4">
					<?= $form->renderField('consignee_legal_opf_id', 'params');?>
					<?= $form->renderField('consignee_physical_document_id', 'params');?>
				</div>
				<div class="span4">
					<?php 
					echo $form->renderField('consignee_inn', 'params');
					echo $form->renderField('consignee_kpp', 'params');
					echo $form->renderField('consignee_inn_kpp', 'params'); ?>
					<?php 
					echo $form->renderField('consignee_seria', 'params');
					echo $form->renderField('consignee_number', 'params');
					echo $form->renderField('consignee_seria_number', 'params'); ?>
				</div>
			</div>	
			<div class="row-fluid">
				<div class="span4">
					<?= $form->renderField('consignee_phone', 'params');?>
				</div>
				<div class="span4">
					<?= $form->renderField('consignee_email', 'params');?>
				</div>
				<div class="span4">
					<?= $form->renderField('consignee_company', 'params');?>
					<?= $form->renderField('consignee_no_document', 'params');?>
				</div>
			</div>	
		</fieldset>
		<fieldset class="adminform control-field">
			<legend><?php echo JText::_ ('PLG_HIKASHOPSHIPPING_DEPARTURE_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span8">
					<?= $form->renderField('departure', 'params');?>
				</div>
				<div class="span4">
					<?= $form->renderField('departure_date', 'params');?>
				</div>
			</div>	
			<div class="row-fluid">
				<div class="span12">
					<?= $form->renderField('departure_from_address', 'params');?>
				</div>
			</div>	
			<div class="row-fluid" data-showon='[{"field":"params[departure_from_address]","values":["0"],"sign":"=","op":""}]'>
				<div class="span12">
					<?= $form->renderField('departure_terminal_id', 'params');?>
				</div>
			</div>
			<div class="row-fluid" data-showon='[{"field":"params[departure_from_address]","values":["1"],"sign":"=","op":""}]'>
				<div class="span12">
					<?= $form->renderField('departure_street', 'params');?>
				</div>
			</div>
			<div class="row-fluid" data-showon='[{"field":"params[departure_from_address]","values":["1"],"sign":"=","op":""}]'>
				<div class="span3">
					<?= $form->renderField('departure_house', 'params');?>
				</div>
				<div class="span3">
					<?= $form->renderField('departure_housing', 'params');?>
				</div>
				<div class="span3">
					<?= $form->renderField('departure_building', 'params');?>
				</div>
				<div class="span3">
					<?= $form->renderField('departure_apartment', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span12">
					<?= $form->renderField('departure_comment', 'params');?>
				</div>
			</div>
		</fieldset>
		<fieldset class="adminform control-field" data-showon='[{"field":"params[departure_from_address]","values":["1"],"sign":"=","op":""}]'>
			<legend><?php echo JText::_ ('PLG_HIKASHOPSHIPPING_PRR_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span3">
					<?php echo $form->renderField('departure_prr', 'params');?>
				</div>
				<div class="span3">
					<?php echo $form->renderField('departure_floor', 'params');?>
				</div>
				<div class="span3">
					<?php echo $form->renderField('departure_lift', 'params');?>
				</div>
			</div>
		</fieldset>
		<fieldset class="adminform control-field">
			<legend><?php echo JText::_ ('PLG_HIKASHOPSHIPPING_DESTINATION_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span8">
					<?= $form->renderField('destination', 'params');?>
				</div>
				<div class="span4">
					<?= $form->renderField('destination_date', 'params');?>
				</div>
			</div>	
			<div class="row-fluid">
				<div class="span12">
					<?= $form->renderField('destination_to_address', 'params');?>
				</div>
			</div>	
			<div class="row-fluid" data-showon='[{"field":"params[destination_to_address]","values":["0"],"sign":"=","op":""}]'>
				<div class="span12">
					<?= $form->renderField('destination_terminal_id', 'params');?>
				</div>
			</div>
			<div class="row-fluid" data-showon='[{"field":"params[destination_to_address]","values":["1"],"sign":"=","op":""}]'>
				<div class="span12">
					<?= $form->renderField('destination_street', 'params');?>
				</div>
			</div>
			<div class="row-fluid" data-showon='[{"field":"params[destination_to_address]","values":["1"],"sign":"=","op":""}]'>
				<div class="span3">
					<?= $form->renderField('destination_house', 'params');?>
				</div>
				<div class="span3">
					<?= $form->renderField('destination_housing', 'params');?>
				</div>
				<div class="span3">
					<?= $form->renderField('destination_building', 'params');?>
				</div>
				<div class="span3">
					<?= $form->renderField('destination_apartment', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span12">
					<?= $form->renderField('destination_comment', 'params');?>
				</div>
			</div>
		</fieldset>
		<fieldset class="adminform control-field" data-showon='[{"field":"params[destination_to_address]","values":["1"],"sign":"=","op":""}]'>
			<legend><?php echo JText::_ ('PLG_HIKASHOPSHIPPING_PRR_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span3">
					<?php echo $form->renderField('destination_prr', 'params');?>
				</div>
				<div class="span3">
					<?php echo $form->renderField('destination_floor', 'params');?>
				</div>
				<div class="span3">
					<?php echo $form->renderField('destination_lift', 'params');?>
				</div>
			</div>
		</fieldset>
		<fieldset class="adminform control-field" id="cargo_fieldset">
			<legend><?php echo JText::_ ('PLG_HIKASHOPSHIPPING_CARGO_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span6">
					<?php echo $form->renderField('cargotype_id', 'params');?>
				</div>
				<div class="span6">
					<?php echo $form->renderField('packing_id', 'params');?>
				</div>
			</div>
			<div class="row-fluid">	
				<div class="span4">
					<?php echo $form->renderField('length', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('width', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('height', 'params');?>
				</div>
			</div>	
			<div class="row-fluid">	
				<div class="span4">
					<?php echo $form->renderField('volume', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('weight', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('estimated_cost', 'params');?>
				</div>
			</div>			
		</fieldset>
		<input type="hidden" name="option" value="<?php echo HIKASHOP_COMPONENT; ?>" />
		<input type="hidden" name="ctrl" value="plugins" />
		<input type="hidden" name="plugin_type" value="shipping" />
		<input type="hidden" name="name" value="<?=$this->name?>" />		
		<input type="hidden" name="task" value="edit" />
		<input type="hidden" name="subtask" value="popupShow"/>
		<input type="hidden" name="cid" value="<?=$this->form_data->order_id;?>"/>
		<input type="hidden" name="tmpl" value="component"/>

		<?php echo JHTML::_( 'form.token' ); ?>
		<div class="row-fluid" style="margin-top:5px">	
			<div id="calcResult">
				<span class="icon-info" aria-hidden="true"></span><?php echo JText::_('PLG_HIKASHOPSHIPPING_ERROR_SHIPPING_COST'); ?>
			</div>
		</div>	
		<?php if(!isset($this->disabled)):?>
			<div class="btn-toolbar">
				<button type="button" class="btn btn-success" onclick="return window.baikalsr.submitOrderForm(this);">
					<span class="icon-checkmark" aria-hidden="true"></span>
					<?php echo JText::_('PLG_HIKASHOPSHIPPING_SEND_REQUEST'); ?>
				</button>
			</div>
		<?php endif;?>
	</form>
</div>
<script type="text/javascript">
jQuery().ready(function ($) {
	$(document)
		.on('change', '.form-control', function(e) {
			<?php if(!isset($this->disabled)):?>
				//window.baikalsr.submitCalcForm();
			<?php endif;?>
		});
    $(document).ready(function ($) {
		<?php if(isset($this->success) && isset($this->shipping_html)):?>
			window.parent.jQuery(window.baikalsr.shipping_info.fieldset).replaceWith(<?= '"'. str_replace('"', '\"', $this->shipping_html) . '"';?>);
		<?php endif;?>
		<?php if(!isset($this->disabled)):?>
			window.baikalsr.submitCalcForm();
		<?php endif;?>
	});
});
</script>